﻿@using System.Security.Claims
@{
    ViewData["Title"] = "Assistant List";
    var role = User.FindFirst(ClaimTypes.Role)?.Value;
    var area = role == Roles.FirmPrincipal ? "firm-principal" : role == Roles.FirmAdmin ? "firm-admin" : "adviser";
    var additionalRoles = ViewBag.additionalRoles;
    bool hasAdviserRole = role == Roles.Adviser || (!string.IsNullOrEmpty(additionalRoles) && additionalRoles.Contains(Roles.Adviser));
}
<div class="container">
    <div class="card">
        <div class="card-header flex-wrap border-0 pt-6 pb-0">
            <div class="card-title mb-0">
                <div class="d-flex justify-content-between">
                    <div class="flex-grow-1">
                        <h3 class="card-label text-primary">
                            Assistant List
                        </h3>
                    </div>
                    <div class="align-self-center">
                        @if (role == Roles.Adviser || hasAdviserRole)
                        {
                            <button class="btn btn-primary btn-sm font-size-h6 font-weight-bold btn-adviser-add btn-add"><i class="fas fa-plus"></i>New Assistant</button>
                        }
                    </div>
                </div>
            </div>
        </div>
        <div class="card-body">
            <div class="datatable datatable-bordered" id="assistant_list"></div>
        </div>
    </div>
</div>
<div class="modal" id="AdviserModal" tabindex="-1" role="dialog" aria-labelledby="exampleModalLabel" aria-hidden="true"></div>
@section scripts{
    <script>
        $(document).on("click", ".btn-adviser-add,.btn-adviser-edit", function() {
            KTApp.blockPage({ overlayColor: '#000000', state: 'primary', message: 'Please wait...' });
            var guid = $(this).attr("data-guid");
            loadPartialView(`admin/adviser/addadviser?guid=${guid}&isAssistant=true`, "AdviserModal", null, function() {
                bindPermissionMultiselect2("AssistantPermission");
            });
            setTimeout(function() { KTApp.unblockPage(); }, 1000);
            $("#AdviserModal").modal({ backdrop: 'static' });
        });
        var ktDataTablOptions = ktDataTableDefaultConfigOptions;
        ktDataTablOptions.source = `admin/adviser/fetchadvisers?isAssistant=true`;
        window['datatable'] = $('#assistant_list').KTDatatable({
            data: ktDataTablOptions,
            columns: [
                { field: 'id', title: '#', width: 30 },
                {
                    field: 'userData.name', title: 'Name', width: 350,
                    template: function(row) {
                        var isCompletedInitialProfile = row.setupCompletedDate != null && row.setupCompletedDate.length > 2
                        var initial = [row.userData.firstName, row.userData.lastName].map((n) => n[0]).join("").substring(0, 2);
                        var color = getRandomColor();
                        var warningHtml = !isCompletedInitialProfile ?
                            ` <span class="fa-stack pulse pulse-warning" data-toggle="tooltip" data-html="true" data-original-title="Password setup is pending" data-placement="right" role="button">
                                                              <i class="fas fa-play fa-stack-1x text-dark icon-nm" style="transform: rotate(30deg);left:1px;top:3px"></i>
                                                              <i class="fas fa-exclamation-triangle fa-stack-1x text-warning"></i>
                                                              <span class="pulse-ring" style="margin-left:-4px;margin-top:-5px"></span>
                                                          </span>` : '';
                        return `<div class="d-flex align-items-center">
                                                                <div class="symbol symbol-40 flex-shrink-0">
                                                                     <div class="symbol-label text-white" style="background:${color}">${initial}</div>
                                                                </div>
                                                                <div class="ml-2">
                                                                    <div class="text-dark-75 font-weight-bold line-height-sm">${row.userData.name}</div>
                                                                    <div class="text-primary">${row.username}</div>
                                                                </div>
                                                                ${warningHtml}
                                                            </div>`;
                    }
                },
                {
                    field: 'roles', title: 'Permission', sortable: false, width: 250,
                    template: function(row) {
                        var html = "";
                        var label_class = "";
                        row.assistantPermissions.forEach(function(item) {
                            label_class = item.permission == AssistantPermissionEnum.AssistantC ? "info" : item.permission == AssistantPermissionEnum.AssistantCQ ? "success" : item.permission == AssistantPermissionEnum.AssistantIQ ? "warning" : "danger";
                            html += `<span class="label label-${label_class} label-inline mr-2 mb-2">${item.permissionString}</span>`;
                        })
                        return html;
                    }
                },
                {
                    field: 'setupCompletedDate', title: 'Password&nbsp;Setup', sortable: false, width: 125,
                    template: function(row) {
                        return getDataTableDateWithHtml(row.setupCompletedDate)
                    },
                },
                {
                    field: 'lastLogin', title: 'Last Login', sortable: false, width: 125,
                    template: function(row) {
                        return getDataTableDateWithHtml(row.lastLogin)
                    }
                },
                {
                    field: 'actions', title: 'Actions', width: 100, sortable: false, overflow: 'visible',
                    template: function(row) {
                        var isSetupCompleted = row.setupCompletedDate != null && new Date(row.setupCompletedDate).getFullYear() != 1;
                        var resend_html = !isSetupCompleted ?
                            `<button class="btn btn-sm btn-icon resend-invitation-button" data-toggle="tooltip" data-original-title="Resend Invitation" onclick="reinvite(this,${AdminRoleEnum.ADVISER},'${row.guid}')">
                                         <img src="/images/email-resend-icon.png" height="25" />
                                         <i class="fa fa-redo text-warning icon-sm resend-invitation-icon" aria-hidden="true" style="left: 64px;"></i>
                                     </button>` : "";
                        return `<button class="btn btn-sm btn-icon ml-2 btn-adviser-edit" data-toggle="tooltip" data-original-title="Edit" data-guid="${row.guid}">
                                              <img src="/images/edit-icon.png" height="25" />
                                        </button>
                                        ${resend_html}`
                    },
                }
            ],
        })
    </script>
}